'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inParents = exports.getModuleParents = exports.getModuleParent = exports.getModuleName = exports.moduleCompare = exports.pickModuleName = exports.originalLoader = undefined;

var _path = require('path');

var _getModule = require('./getModule');

var _getModule2 = _interopRequireDefault(_getModule);

var _executor = require('./executor');

var _executor2 = _interopRequireDefault(_executor);

var _asyncModules = require('./asyncModules');

var _asyncModules2 = _interopRequireDefault(_asyncModules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var originalLoader = exports.originalLoader = _getModule2.default._load;

var NodeModule = {
  overloadRequire: function overloadRequire() {
    _getModule2.default._load = _executor2.default;
    // overload modules by internally
  },
  restoreRequire: function restoreRequire() {
    _getModule2.default._load = originalLoader;
  },
  probeAsyncModules: function probeAsyncModules() {
    var load = _getModule2.default._load;
    _getModule2.default._load = _asyncModules2.default.load(this);
    return _asyncModules2.default.execute().then(function () {
      _getModule2.default._load = load;
    });
  },
  _resolveFilename: function _resolveFilename(fileName, module) {
    return _getModule2.default._resolveFilename(fileName, module);
  },


  get _cache() {
    return _getModule2.default._cache;
  },

  relativeFileName: function relativeFileName(name, parent) {
    if (name[0] == '.') {
      return this._resolveFilename(name, parent);
    }
    return name;
  },
  require: function require(name, parentModule) {
    return (0, _executor.requireModule)(name, parentModule);
  }
};

var toModule = function toModule(name) {
  return name && require.cache[name];
};

var pickModuleName = exports.pickModuleName = function pickModuleName(fileName, parent) {
  if (typeof __webpack_modules__ !== 'undefined') {
    var targetFile = (0, _path.resolve)((0, _path.dirname)(getModuleName(parent)), fileName);
    return Object.keys(__webpack_modules__).find(function (name) {
      return name.indexOf(targetFile) > 0;
    });
  } else {
    return fileName;
  }
};

var moduleCompare = exports.moduleCompare = function moduleCompare(a, b) {
  return a === b || getModuleName(a) === getModuleName(b);
};

var getModuleName = exports.getModuleName = function getModuleName(module) {
  return module.filename || module.i;
};
var getModuleParent = exports.getModuleParent = function getModuleParent(module) {
  return module && (module.parent || toModule(module.parents && module.parents[0]));
};
var getModuleParents = exports.getModuleParents = function getModuleParents(module) {
  return module && (module.parent ? [getModuleName(module.parent)] : module.parents);
};

var inParents = exports.inParents = function inParents(a, b) {
  var B = getModuleName(b);
  return !!getModuleParents(a).find(function (x) {
    return x === B;
  });
};

exports.default = NodeModule;